-- Copyright (C) 2010 Noé Falzon

-- This program is  free software:  you can redistribute it and/or modify it
-- under  the terms  of the  GNU General Public License  as published by the
-- Free Software Foundation, version 3 of the License.
--
-- This program  is  distributed  in the hope  that it will  be useful,  but
-- WITHOUT  ANY WARRANTY;  without  even the implied  warranty of MERCHANTA-
-- BILITY  or  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
-- License for more details.
--
-- You should have received a copy of the  GNU General Public License  along
-- with this program. If not, see <http://www.gnu.org/licenses/>.

require "class"
obj = require "objloader"

Menu = class()

-- tab of {mesh, callback}
function Menu:init(tab)
	
	if not tab or #tab == 0 then
		return
	end
	
	self.cb = tab
	self.sel = 1

	return self
end

function Menu:draw()
	
	gl.PushMatrix()
	
	local w = (#self.cb-1)
	local x = -w/2
	
	gl.Translate(x,0,-4)
	gl.Color(col.menu)
	gl.Enable('LIGHTING')
	gl.Enable('NORMALIZE')	-- because of the scaling
	
	gl.Light('LIGHT0','POSITION',{-1,0,1,0})
	
	for i,v in ipairs(self.cb) do
		
		gl.PushMatrix()
		
		if self.sel == i then
			gl.Translate(0,sin(gTicks/500*math.pi*2)*0.05,0.5)
			gl.Rotate(gTicks/1000*360,0,1,0)
		end
		
		if v[3] then
			gl.Scale(v[3],v[3],v[3])
		end
		obj.drawDisplayList(v[1])
		gl.PopMatrix()
		
		gl.Translate(1,0,0)
	end
	gl.PopMatrix()
	
	gl.Disable('LIGHTING')
	gl.Disable('NORMALIZE')
	
	gl.LineWidth(2)
	gl.Color(1,1,1)
	
	gl.PushMatrix()
		gl.Translate(-2,1.2,-4)		
		gl.Scale(0.1,0.1,0.1)
		drawNumber(#game.dudes)
		
	gl.PopMatrix()
	
	gl.PushMatrix()
		gl.Translate(-1,1.2,-4)		
		gl.Scale(0.1,0.1,0.1)
		drawNumber(game.saved)
	gl.PopMatrix()
	
	
end	

function Menu:input(dt)
	
	evol.treatAllInput(gMap,{
		
		right = function()
			self.sel = self.sel % #self.cb + 1
		end,
		
		left = function()
			self.sel = (self.sel - 2) % #self.cb + 1
		end,
		
		cancel = function()
			gMenu = nil
		end,
		
		action = function()
			self.cb[self.sel][2]()
			gMenu = nil
		end

	})
	
end
