-- Copyright (C) 2010 Noé Falzon

-- This program is  free software:  you can redistribute it and/or modify it
-- under  the terms  of the  GNU General Public License  as published by the
-- Free Software Foundation, version 3 of the License.
--
-- This program  is  distributed  in the hope  that it will  be useful,  but
-- WITHOUT  ANY WARRANTY;  without  even the implied  warranty of MERCHANTA-
-- BILITY  or  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
-- License for more details.
--
-- You should have received a copy of the  GNU General Public License  along
-- with this program. If not, see <http://www.gnu.org/licenses/>.

require "evol"
require "LuaGL"
require "LuaGlu"
require "LuaGlut"

require "utils"
require "Heightfield"
require "Game"


local arg = {...}

function init_evol_GL()
	
	--read in CL arguments
	
	local w = tonumber(arg[1])
	local h = tonumber(arg[2])
	local fs = arg[3] and true or false
	
	if not w or not h then
		print("Usage: lua main.lua width height ['fullscreen']")
		os.exit()
	end
	
	
	-- view: fourth argument is true to have OpenGL
	evol.init(w,h,fs, true)
	
	evol.showCursor(false)
	
	gl.ClearColor(0,0,0,0)
	gl.ClearDepth(1.0)
	gl.Enable('DEPTH_TEST')
	gl.DepthFunc('LEQUAL')
	gl.Enable('COLOR_MATERIAL')
	gl.Hint('PERSPECTIVE_CORRECTION_HINT','NICEST')

	gl.Viewport(0, 0, evol.width, evol.height)

	gl.MatrixMode('PROJECTION')   -- Select The Projection Matrix
	gl.LoadIdentity()             -- Reset The Projection Matrix

	glu.Perspective(45, evol.width / evol.height, 1, 500)
	
	gl.ShadeModel('FLAT')
end




-- main drawing routine

function main()
	
	init_evol_GL()
	math.randomseed(os.time())
	
	-- music, maestro!
	local zik = evol.loadMusic("snd/Mercy.ogg")
	evol.play(zik)
	
	game = Game(100)
	
	
	while not quit do
		
		gDt,gFps,gTicks = evolcore.timer()
		
		game:update(gDt)
		
		game:draw()
		
		evol.flip()
	end
	

	evol.quit()
end

main()
